use strict;

my ($N, $G, $M, $L, $S, $randseed) = (@ARGV);
srand($randseed);

my @list;

for(1..$N/$G){
  my $start = '';
  
  sub gen_str{
    my $l = (defined $_[0] ? $_[0] : $L - length($start) - 1);
    my $result = ('a'..'z', '0'..'9')[rand 36];
    for(2..$l){
      $result .= ('a'..'z', '0'..'9', ' ', '_', '-')[rand 39];
    }
    return $result;
  }

  $start .= ('a'..'z', '0'..'9')[rand 36] for 1..$S;
  push @list, $start . (' ', '_', '-')[rand 3] . gen_str for 1..$G;
}  

push @list, gen_str($L) for 1..$N - $G * int $N/$G;

for(1..$N**2){
  my ($a, $b) = (rand $N, rand $N);
  ($list[$a], $list[$b]) = ($list[$b], $list[$a]);
}
  

$, = "\n";
open my $fo, '>input.txt';
print $fo "$N\n";
print $fo @list;
print $fo "\n";
print $fo "$M\n";
undef $,;
print $fo $list[rand @list], "\n" for 1..$M;
close $fo;