#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

vector<string> list;
string s;
int i, j, n, m;

bool is_separator(const char& a){
  return (a == ' ' || a == '_' || a == '-');
}

bool common_prefix(const string& a, const string &b){
  int i = 0;
  while(i < a.length() && i < b.length() && a[i] == b[i]){
    if(is_separator(a[i])){
      return true;
    }
    i++;
  }
  return is_separator(a[i]) && is_separator(b[i]);
}

int main(){
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  cin >> n; getline(cin, s);
  for(i = 0; i < n; i++){
    getline(cin, s);
    list.push_back(s);
  }
  sort(list.begin(), list.end());

  cin >> m; getline(cin, s);
  for(j = 0; j < m; j++){
    getline(cin, s);
    for(i = 0; i < n; i++){
      if(common_prefix(list[i]+'_', s+'_')){
        cout << list[i] << endl;
      }
    }
  }
  fclose(stdin);
  fclose(stdout);
}
